diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/mac-rx-middle.cc ns-3.42/src/wifi/model/mac-rx-middle.cc
--- ns-3.41/src/wifi/model/mac-rx-middle.cc	2024-02-09 14:44:08.589794900 -0800
+++ ns-3.42/src/wifi/model/mac-rx-middle.cc	2024-05-29 15:29:47.204074000 -0700
@@ -58,11 +58,6 @@
         m_defragmenting = false;
     }
 
-    ~OriginatorRxStatus()
-    {
-        m_fragments.clear();
-    }
-
     /**
      * Check if we are de-fragmenting packets.
      *
@@ -167,16 +162,6 @@
 MacRxMiddle::~MacRxMiddle()
 {
     NS_LOG_FUNCTION_NOARGS();
-    for (auto i = m_originatorStatus.begin(); i != m_originatorStatus.end(); i++)
-    {
-        delete (*i).second;
-    }
-    m_originatorStatus.erase(m_originatorStatus.begin(), m_originatorStatus.end());
-    for (auto i = m_qosOriginatorStatus.begin(); i != m_qosOriginatorStatus.end(); i++)
-    {
-        delete (*i).second;
-    }
-    m_qosOriginatorStatus.erase(m_qosOriginatorStatus.begin(), m_qosOriginatorStatus.end());
 }
 
 void
@@ -186,63 +171,51 @@
     m_callback = callback;
 }
 
-OriginatorRxStatus*
-MacRxMiddle::Lookup(const WifiMacHeader* hdr)
+OriginatorRxStatus&
+MacRxMiddle::Lookup(const WifiMacHeader& hdr)
 {
     NS_LOG_FUNCTION(hdr);
-    OriginatorRxStatus* originator;
-    Mac48Address source = hdr->GetAddr2();
-    if (hdr->IsQosData() && !hdr->GetAddr2().IsGroup())
+    const auto source = hdr.GetAddr2();
+    if (hdr.IsQosData() && !source.IsGroup())
     {
         /* only for QoS data non-broadcast frames */
-        originator = m_qosOriginatorStatus[std::make_pair(source, hdr->GetQosTid())];
-        if (originator == nullptr)
-        {
-            originator = new OriginatorRxStatus();
-            m_qosOriginatorStatus[std::make_pair(source, hdr->GetQosTid())] = originator;
-        }
-    }
-    else
-    {
-        /* - management frames
-         * - QoS data broadcast frames
-         * - non-QoS data frames
-         * see section 7.1.3.4.1
-         */
-        originator = m_originatorStatus[source];
-        if (originator == nullptr)
-        {
-            originator = new OriginatorRxStatus();
-            m_originatorStatus[source] = originator;
-        }
-    }
-    return originator;
+        const auto key = std::make_pair(source, hdr.GetQosTid());
+        auto [it, inserted] = m_qosOriginatorStatus.try_emplace(key);
+        return it->second;
+    }
+    /* - management frames
+     * - QoS data broadcast frames
+     * - non-QoS data frames
+     * see section 7.1.3.4.1
+     */
+    auto [it, inserted] = m_originatorStatus.try_emplace(source);
+    return it->second;
 }
 
 bool
-MacRxMiddle::IsDuplicate(const WifiMacHeader* hdr, OriginatorRxStatus* originator) const
+MacRxMiddle::IsDuplicate(const WifiMacHeader& hdr, const OriginatorRxStatus& originator) const
 {
-    NS_LOG_FUNCTION(hdr << originator);
-    return hdr->IsRetry() && originator->GetLastSequenceControl() == hdr->GetSequenceControl();
+    NS_LOG_FUNCTION(hdr << &originator);
+    return hdr.IsRetry() && originator.GetLastSequenceControl() == hdr.GetSequenceControl();
 }
 
 Ptr<const Packet>
 MacRxMiddle::HandleFragments(Ptr<const Packet> packet,
-                             const WifiMacHeader* hdr,
-                             OriginatorRxStatus* originator)
+                             const WifiMacHeader& hdr,
+                             OriginatorRxStatus& originator)
 {
-    NS_LOG_FUNCTION(packet << hdr << originator);
-    if (originator->IsDeFragmenting())
+    NS_LOG_FUNCTION(packet << hdr << &originator);
+    if (originator.IsDeFragmenting())
     {
-        if (hdr->IsMoreFragments())
+        if (hdr.IsMoreFragments())
         {
-            if (originator->IsNextFragment(hdr->GetSequenceControl()))
+            if (originator.IsNextFragment(hdr.GetSequenceControl()))
             {
-                NS_LOG_DEBUG("accumulate fragment seq=" << hdr->GetSequenceNumber()
-                                                        << ", frag=" << +hdr->GetFragmentNumber()
+                NS_LOG_DEBUG("accumulate fragment seq=" << hdr.GetSequenceNumber()
+                                                        << ", frag=" << +hdr.GetFragmentNumber()
                                                         << ", size=" << packet->GetSize());
-                originator->AccumulateFragment(packet);
-                originator->SetSequenceControl(hdr->GetSequenceControl());
+                originator.AccumulateFragment(packet);
+                originator.SetSequenceControl(hdr.GetSequenceControl());
             }
             else
             {
@@ -252,13 +225,13 @@
         }
         else
         {
-            if (originator->IsNextFragment(hdr->GetSequenceControl()))
+            if (originator.IsNextFragment(hdr.GetSequenceControl()))
             {
-                NS_LOG_DEBUG("accumulate last fragment seq="
-                             << hdr->GetSequenceNumber() << ", frag=" << +hdr->GetFragmentNumber()
-                             << ", size=" << hdr->GetSize());
-                Ptr<Packet> p = originator->AccumulateLastFragment(packet);
-                originator->SetSequenceControl(hdr->GetSequenceControl());
+                NS_LOG_DEBUG("accumulate last fragment seq=" << hdr.GetSequenceNumber() << ", frag="
+                                                             << +hdr.GetFragmentNumber()
+                                                             << ", size=" << hdr.GetSize());
+                Ptr<Packet> p = originator.AccumulateLastFragment(packet);
+                originator.SetSequenceControl(hdr.GetSequenceControl());
                 return p;
             }
             else
@@ -270,13 +243,13 @@
     }
     else
     {
-        if (hdr->IsMoreFragments())
+        if (hdr.IsMoreFragments())
         {
-            NS_LOG_DEBUG("accumulate first fragment seq=" << hdr->GetSequenceNumber()
-                                                          << ", frag=" << +hdr->GetFragmentNumber()
+            NS_LOG_DEBUG("accumulate first fragment seq=" << hdr.GetSequenceNumber()
+                                                          << ", frag=" << +hdr.GetFragmentNumber()
                                                           << ", size=" << packet->GetSize());
-            originator->AccumulateFirstFragment(packet);
-            originator->SetSequenceControl(hdr->GetSequenceControl());
+            originator.AccumulateFirstFragment(packet);
+            originator.SetSequenceControl(hdr.GetSequenceControl());
             return nullptr;
         }
         else
@@ -291,10 +264,10 @@
 {
     NS_LOG_FUNCTION(*mpdu << +linkId);
     // consider the MAC header of the original MPDU (makes a difference for data frames only)
-    const WifiMacHeader* hdr = &mpdu->GetOriginal()->GetHeader();
-    NS_ASSERT(hdr->IsData() || hdr->IsMgt());
+    const auto& hdr = mpdu->GetOriginal()->GetHeader();
+    NS_ASSERT(hdr.IsData() || hdr.IsMgt());
 
-    OriginatorRxStatus* originator = Lookup(hdr);
+    auto& originator = Lookup(hdr);
     /**
      * The check below is really unneeded because it can fail in a lot of
      * normal cases. Specifically, it is possible for sequence numbers to
@@ -304,18 +277,18 @@
      * So, this check cannot be used to discard old duplicate frames. It is
      * thus here only for documentation purposes.
      */
-    if (!(SequenceNumber16(originator->GetLastSequenceControl()) <
-          SequenceNumber16(hdr->GetSequenceControl())))
+    if (!(SequenceNumber16(originator.GetLastSequenceControl()) <
+          SequenceNumber16(hdr.GetSequenceControl())))
     {
         NS_LOG_DEBUG("Sequence numbers have looped back. last recorded="
-                     << originator->GetLastSequenceControl()
-                     << " currently seen=" << hdr->GetSequenceControl());
+                     << originator.GetLastSequenceControl()
+                     << " currently seen=" << hdr.GetSequenceControl());
     }
     // filter duplicates.
     if (IsDuplicate(hdr, originator))
     {
-        NS_LOG_DEBUG("duplicate from=" << hdr->GetAddr2() << ", seq=" << hdr->GetSequenceNumber()
-                                       << ", frag=" << +hdr->GetFragmentNumber());
+        NS_LOG_DEBUG("duplicate from=" << hdr.GetAddr2() << ", seq=" << hdr.GetSequenceNumber()
+                                       << ", frag=" << +hdr.GetFragmentNumber());
         return;
     }
     Ptr<const Packet> aggregate = HandleFragments(mpdu->GetPacket(), hdr, originator);
@@ -323,11 +296,11 @@
     {
         return;
     }
-    NS_LOG_DEBUG("forwarding data from=" << hdr->GetAddr2() << ", seq=" << hdr->GetSequenceNumber()
-                                         << ", frag=" << +hdr->GetFragmentNumber());
-    if (!hdr->GetAddr1().IsGroup())
+    NS_LOG_DEBUG("forwarding data from=" << hdr.GetAddr2() << ", seq=" << hdr.GetSequenceNumber()
+                                         << ", frag=" << +hdr.GetFragmentNumber());
+    if (!hdr.GetAddr1().IsGroup())
     {
-        originator->SetSequenceControl(hdr->GetSequenceControl());
+        originator.SetSequenceControl(hdr.GetSequenceControl());
     }
     if (aggregate == mpdu->GetPacket())
     {
@@ -339,7 +312,7 @@
         // A-MSDUs saves us the time to deaggregate the A-MSDU in MSDUs (which are
         // kept separate in the received mpdu) and allows us to pass the originally
         // transmitted packets (i.e., with the same UID) to the receiver.
-        m_callback(Create<WifiMpdu>(aggregate, *hdr), linkId);
+        m_callback(Create<WifiMpdu>(aggregate, hdr), linkId);
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/mac-rx-middle.h ns-3.42/src/wifi/model/mac-rx-middle.h
--- ns-3.41/src/wifi/model/mac-rx-middle.h	2024-02-09 14:44:08.589794900 -0800
+++ ns-3.42/src/wifi/model/mac-rx-middle.h	2024-05-29 15:29:47.204074000 -0700
@@ -45,7 +45,7 @@
     /**
      * typedef for callback
      */
-    typedef Callback<void, Ptr<const WifiMpdu>, uint8_t /* link ID */> ForwardUpCallback;
+    using ForwardUpCallback = Callback<void, Ptr<const WifiMpdu>, uint8_t /* link ID */>;
 
     MacRxMiddle();
     ~MacRxMiddle();
@@ -77,7 +77,7 @@
      *
      * \return OriginatorRxStatus
      */
-    OriginatorRxStatus* Lookup(const WifiMacHeader* hdr);
+    OriginatorRxStatus& Lookup(const WifiMacHeader& hdr);
     /**
      * Check if we have already received the packet from the sender before
      * (by looking at the sequence control field).
@@ -88,7 +88,7 @@
      * \return true if we already received the packet previously,
      *         false otherwise
      */
-    bool IsDuplicate(const WifiMacHeader* hdr, OriginatorRxStatus* originator) const;
+    bool IsDuplicate(const WifiMacHeader& hdr, const OriginatorRxStatus& originator) const;
     /**
      * Check if the received packet is a fragment and handle it appropriately.
      * If the packet is not a fragment, the method returns the packet.
@@ -105,27 +105,30 @@
      *         0 if we failed to reassemble the packet (e.g. missing fragments/out-of-order).
      */
     Ptr<const Packet> HandleFragments(Ptr<const Packet> packet,
-                                      const WifiMacHeader* hdr,
-                                      OriginatorRxStatus* originator);
+                                      const WifiMacHeader& hdr,
+                                      OriginatorRxStatus& originator);
 
     /**
      * typedef for a map between address and OriginatorRxStatus
      */
-    typedef std::map<Mac48Address, OriginatorRxStatus*, std::less<>> Originators;
+    using Originators = std::map<Mac48Address, OriginatorRxStatus, std::less<>>;
+
     /**
      * typedef for a map between address, OriginatorRxStatus, and Traffic ID
      */
-    typedef std::map<std::pair<Mac48Address, uint8_t>, OriginatorRxStatus*, std::less<>>
-        QosOriginators;
+    using QosOriginators =
+        std::map<std::pair<Mac48Address, uint8_t>, OriginatorRxStatus, std::less<>>;
+
     /**
      * typedef for an iterator for Originators
      */
-    typedef std::map<Mac48Address, OriginatorRxStatus*, std::less<>>::iterator OriginatorsI;
+    using OriginatorsI = std::map<Mac48Address, OriginatorRxStatus, std::less<>>::iterator;
+
     /**
      * typedef for an iterator for QosOriginators
      */
-    typedef std::map<std::pair<Mac48Address, uint8_t>, OriginatorRxStatus*, std::less<>>::iterator
-        QosOriginatorsI;
+    using QosOriginatorsI =
+        std::map<std::pair<Mac48Address, uint8_t>, OriginatorRxStatus, std::less<>>::iterator;
 
     Originators m_originatorStatus;       ///< originator status
     QosOriginators m_qosOriginatorStatus; ///< QOS originator status
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/mgt-action-headers.cc ns-3.42/src/wifi/model/mgt-action-headers.cc
--- ns-3.41/src/wifi/model/mgt-action-headers.cc	2024-02-09 14:44:08.589794900 -0800
+++ ns-3.42/src/wifi/model/mgt-action-headers.cc	2024-05-29 15:29:47.204074000 -0700
@@ -25,6 +25,9 @@
 
 #include "ns3/multi-link-element.h"
 #include "ns3/packet.h"
+#include "ns3/simulator.h"
+
+#include <vector>
 
 namespace ns3
 {
@@ -191,6 +194,9 @@
         case QAB_RESPONSE:
             retval.publicAction = QAB_RESPONSE;
             break;
+        case FILS_DISCOVERY:
+            retval.publicAction = FILS_DISCOVERY;
+            break;
         default:
             NS_FATAL_ERROR("Unknown public action code");
             retval.publicAction = QAB_REQUEST; /* quiet compiler */
@@ -293,9 +299,7 @@
     case MULTIHOP: // not yet supported
         switch (m_actionValue)
         {
-        case PROXY_UPDATE: // not used so far
-            retval.multihopAction = PROXY_UPDATE;
-            break;
+        case PROXY_UPDATE:              // not used so far
         case PROXY_UPDATE_CONFIRMATION: // not used so far
             retval.multihopAction = PROXY_UPDATE;
             break;
@@ -553,6 +557,7 @@
         {
             CASE_ACTION_VALUE(QAB_REQUEST);
             CASE_ACTION_VALUE(QAB_RESPONSE);
+            CASE_ACTION_VALUE(FILS_DISCOVERY);
         default:
             NS_FATAL_ERROR("Unknown public action code");
         }
@@ -1349,4 +1354,411 @@
     return list;
 }
 
+/***************************************************
+ *                 FILS Discovery
+ ****************************************************/
+
+NS_OBJECT_ENSURE_REGISTERED(FilsDiscHeader);
+
+TypeId
+FilsDiscHeader::GetTypeId()
+{
+    static TypeId tid = TypeId("ns3::FilsDiscHeader")
+                            .SetParent<Header>()
+                            .SetGroupName("Wifi")
+                            .AddConstructor<FilsDiscHeader>();
+    return tid;
+}
+
+TypeId
+FilsDiscHeader::GetInstanceTypeId() const
+{
+    return GetTypeId();
+}
+
+FilsDiscHeader::FilsDiscHeader()
+    : m_len(m_frameCtl.m_lenPresenceInd),
+      m_fdCap(m_frameCtl.m_capPresenceInd),
+      m_primaryCh(m_frameCtl.m_primChPresenceInd),
+      m_apConfigSeqNum(m_frameCtl.m_apCsnPresenceInd),
+      m_accessNetOpt(m_frameCtl.m_anoPresenceInd),
+      m_chCntrFreqSeg1(m_frameCtl.m_chCntrFreqSeg1PresenceInd)
+{
+}
+
+void
+FilsDiscHeader::SetSsid(const std::string& ssid)
+{
+    m_ssid = ssid;
+    m_frameCtl.m_ssidLen = ssid.length() - 1;
+}
+
+const std::string&
+FilsDiscHeader::GetSsid() const
+{
+    return m_ssid;
+}
+
+uint32_t
+FilsDiscHeader::GetInformationFieldSize() const
+{
+    auto size = GetSizeNonOptSubfields();
+    size += m_len.has_value() ? 1 : 0;
+    size += m_fdCap.has_value() ? 2 : 0;
+    size += m_opClass.has_value() ? 1 : 0;
+    size += m_primaryCh.has_value() ? 1 : 0;
+    size += m_apConfigSeqNum.has_value() ? 1 : 0;
+    size += m_accessNetOpt.has_value() ? 1 : 0;
+    size += m_chCntrFreqSeg1.has_value() ? 1 : 0;
+    return size;
+}
+
+uint32_t
+FilsDiscHeader::GetSerializedSize() const
+{
+    auto size = GetInformationFieldSize();
+    // Optional elements
+    size += m_rnr.has_value() ? m_rnr->GetSerializedSize() : 0;
+    size += m_tim.has_value() ? m_tim->GetSerializedSize() : 0;
+    return size;
+}
+
+uint32_t
+FilsDiscHeader::GetSizeNonOptSubfields() const
+{
+    return 2                  /* FILS Discovery Frame Control */
+           + 8                /* Timestamp */
+           + 2                /* Beacon Interval */
+           + m_ssid.length(); /* SSID */
+}
+
+void
+FilsDiscHeader::SetLengthSubfield()
+{
+    m_len.reset(); // so that Length size is not included by GetInformationFieldSize()
+    auto infoFieldSize = GetInformationFieldSize();
+    auto nonOptSubfieldsSize = GetSizeNonOptSubfields();
+    NS_ABORT_MSG_IF(infoFieldSize < nonOptSubfieldsSize, "Length subfield is less than 0");
+    m_len = infoFieldSize - nonOptSubfieldsSize;
+}
+
+void
+FilsDiscHeader::Print(std::ostream& os) const
+{
+    os << "Control=" << m_frameCtl << ", "
+       << "Time Stamp=" << m_timeStamp << ", "
+       << "Beacon Interval=" << m_beaconInt << ", "
+       << "SSID=" << m_ssid << ", ";
+    if (m_len.has_value())
+    {
+        os << "Length=" << *m_len << ", ";
+    }
+    if (m_fdCap.has_value())
+    {
+        os << "FD Capability=" << *m_fdCap << ", ";
+    }
+    if (m_opClass.has_value())
+    {
+        os << "Operating Class=" << *m_opClass << ", ";
+    }
+    if (m_primaryCh.has_value())
+    {
+        os << "Primary Channel=" << *m_primaryCh << ", ";
+    }
+    if (m_apConfigSeqNum.has_value())
+    {
+        os << "AP-CSN=" << *m_apConfigSeqNum << ", ";
+    }
+    if (m_accessNetOpt.has_value())
+    {
+        os << "ANO=" << *m_accessNetOpt << ", ";
+    }
+    if (m_chCntrFreqSeg1.has_value())
+    {
+        os << "Channel Center Frequency Seg 1=" << *m_chCntrFreqSeg1 << ", ";
+    }
+    if (m_tim.has_value())
+    {
+        os << "Traffic Indicator Map=" << *m_tim;
+    }
+}
+
+void
+FilsDiscHeader::Serialize(Buffer::Iterator start) const
+{
+    Buffer::Iterator i = start;
+    m_frameCtl.Serialize(i);
+    i.WriteHtolsbU64(Simulator::Now().GetMicroSeconds()); // Time stamp
+    i.WriteHtolsbU16(m_beaconInt);
+    i.Write(reinterpret_cast<const uint8_t*>(m_ssid.data()), m_ssid.length());
+    if (m_len.has_value())
+    {
+        i.WriteU8(*m_len);
+    }
+    if (m_fdCap.has_value())
+    {
+        m_fdCap->Serialize(i);
+    }
+    NS_ASSERT(m_opClass.has_value() == m_primaryCh.has_value());
+    if (m_opClass.has_value())
+    {
+        i.WriteU8(*m_opClass);
+    }
+    if (m_primaryCh.has_value())
+    {
+        i.WriteU8(*m_primaryCh);
+    }
+    if (m_apConfigSeqNum.has_value())
+    {
+        i.WriteU8(*m_apConfigSeqNum);
+    }
+    if (m_accessNetOpt.has_value())
+    {
+        i.WriteU8(*m_accessNetOpt);
+    }
+    if (m_chCntrFreqSeg1.has_value())
+    {
+        i.WriteU8(*m_chCntrFreqSeg1);
+    }
+    i = m_rnr.has_value() ? m_rnr->Serialize(i) : i;
+    i = m_tim.has_value() ? m_tim->Serialize(i) : i;
+}
+
+uint32_t
+FilsDiscHeader::Deserialize(Buffer::Iterator start)
+{
+    Buffer::Iterator i = start;
+    auto nOctets = m_frameCtl.Deserialize(i);
+    i.Next(nOctets);
+    m_timeStamp = i.ReadLsbtohU64();
+    m_beaconInt = i.ReadLsbtohU16();
+    std::vector<uint8_t> ssid(m_frameCtl.m_ssidLen + 2);
+    i.Read(ssid.data(), m_frameCtl.m_ssidLen + 1);
+    ssid[m_frameCtl.m_ssidLen + 1] = 0;
+    m_ssid = std::string(reinterpret_cast<char*>(ssid.data()));
+    // Optional subfields
+    if (m_frameCtl.m_lenPresenceInd)
+    {
+        m_len = i.ReadU8();
+    }
+    if (m_frameCtl.m_capPresenceInd)
+    {
+        nOctets = m_fdCap->Deserialize(i);
+        i.Next(nOctets);
+    }
+    if (m_frameCtl.m_primChPresenceInd)
+    {
+        m_opClass = i.ReadU8();
+        m_primaryCh = i.ReadU8();
+    }
+    if (m_frameCtl.m_apCsnPresenceInd)
+    {
+        m_apConfigSeqNum = i.ReadU8();
+    }
+    if (m_frameCtl.m_anoPresenceInd)
+    {
+        m_accessNetOpt = i.ReadU8();
+    }
+    if (m_frameCtl.m_chCntrFreqSeg1PresenceInd)
+    {
+        m_chCntrFreqSeg1 = i.ReadU8();
+    }
+    // Optional elements
+    m_rnr.emplace();
+    auto tmp = i;
+    i = m_rnr->DeserializeIfPresent(i);
+    if (i.GetDistanceFrom(tmp) == 0)
+    {
+        m_rnr.reset();
+    }
+
+    m_tim.emplace();
+    tmp = i;
+    i = m_tim->DeserializeIfPresent(i);
+    if (i.GetDistanceFrom(tmp) == 0)
+    {
+        m_tim.reset();
+    }
+
+    return i.GetDistanceFrom(start);
+}
+
+std::ostream&
+operator<<(std::ostream& os, const FilsDiscHeader::FilsDiscFrameControl& control)
+{
+    os << "ssidLen:" << control.m_ssidLen << " capPresenceInd:" << control.m_capPresenceInd
+       << " shortSsidInd:" << control.m_shortSsidInd
+       << " apCsnPresenceInd:" << control.m_apCsnPresenceInd
+       << " anoPresenceInd:" << control.m_anoPresenceInd
+       << " chCntrFreqSeg1PresenceInd:" << control.m_chCntrFreqSeg1PresenceInd
+       << " primChPresenceInd:" << control.m_primChPresenceInd
+       << " rsnInfoPresenceInd:" << control.m_rsnInfoPresenceInd
+       << " lenPresenceInd:" << control.m_lenPresenceInd
+       << " mdPresenceInd:" << control.m_mdPresenceInd;
+    return os;
+}
+
+void
+FilsDiscHeader::FilsDiscFrameControl::Serialize(Buffer::Iterator& start) const
+{
+    uint16_t val = m_ssidLen | ((m_capPresenceInd ? 1 : 0) << 5) | (m_shortSsidInd << 6) |
+                   ((m_apCsnPresenceInd ? 1 : 0) << 7) | ((m_anoPresenceInd ? 1 : 0) << 8) |
+                   ((m_chCntrFreqSeg1PresenceInd ? 1 : 0) << 9) |
+                   ((m_primChPresenceInd ? 1 : 0) << 10) | (m_rsnInfoPresenceInd << 11) |
+                   ((m_lenPresenceInd ? 1 : 0) << 12) | (m_mdPresenceInd << 13);
+    start.WriteHtolsbU16(val);
+}
+
+uint32_t
+FilsDiscHeader::FilsDiscFrameControl::Deserialize(Buffer::Iterator start)
+{
+    auto val = start.ReadLsbtohU16();
+
+    m_ssidLen = val & 0x001f;
+    m_capPresenceInd = ((val >> 5) & 0x0001) == 1;
+    m_shortSsidInd = (val >> 6) & 0x0001;
+    m_apCsnPresenceInd = ((val >> 7) & 0x0001) == 1;
+    m_anoPresenceInd = ((val >> 8) & 0x0001) == 1;
+    m_chCntrFreqSeg1PresenceInd = ((val >> 9) & 0x0001) == 1;
+    m_primChPresenceInd = ((val >> 10) & 0x0001) == 1;
+    m_rsnInfoPresenceInd = (val >> 11) & 0x0001;
+    m_lenPresenceInd = ((val >> 12) & 0x0001) == 1;
+    m_mdPresenceInd = (val >> 13) & 0x0001;
+
+    return 2;
+}
+
+std::ostream&
+operator<<(std::ostream& os, const FilsDiscHeader::FdCapability& capability)
+{
+    os << "ess:" << capability.m_ess << " privacy:" << capability.m_privacy
+       << " channelWidth:" << capability.m_chWidth << " maxNss:" << capability.m_maxNss
+       << " multiBssidInd:" << capability.m_multiBssidPresenceInd
+       << " phyIdx:" << capability.m_phyIdx << " minRate:" << capability.m_minRate;
+    return os;
+}
+
+void
+FilsDiscHeader::FdCapability::Serialize(Buffer::Iterator& start) const
+{
+    uint16_t val = m_ess | (m_privacy << 1) | (m_chWidth << 2) | (m_maxNss << 5) |
+                   (m_multiBssidPresenceInd << 9) | (m_phyIdx << 10) | (m_minRate << 13);
+    start.WriteHtolsbU16(val);
+}
+
+uint32_t
+FilsDiscHeader::FdCapability::Deserialize(Buffer::Iterator start)
+{
+    auto val = start.ReadLsbtohU16();
+
+    m_ess = val & 0x0001;
+    m_privacy = (val >> 1) & 0x0001;
+    m_chWidth = (val >> 2) & 0x0007;
+    m_maxNss = (val >> 5) & 0x0007;
+    m_multiBssidPresenceInd = (val >> 9) & 0x0001;
+    m_phyIdx = (val >> 10) & 0x0007;
+    m_minRate = (val >> 13) & 0x0007;
+
+    return 2;
+}
+
+void
+FilsDiscHeader::FdCapability::SetOpChannelWidth(uint16_t width)
+{
+    m_chWidth = (width == 20 || width == 22) ? 0
+                : (width == 40)              ? 1
+                : (width == 80)              ? 2
+                : (width == 160)             ? 3
+                                             : 4;
+}
+
+uint16_t
+FilsDiscHeader::FdCapability::GetOpChannelWidth() const
+{
+    switch (m_chWidth)
+    {
+    case 0:
+        return m_phyIdx == 0 ? 22 : 20; // PHY Index 0 indicates 802.11b
+    case 1:
+        return 40;
+    case 2:
+        return 80;
+    case 3:
+        return 160;
+    default:
+        NS_ABORT_MSG("Reserved value: " << +m_chWidth);
+    }
+    return 0;
+}
+
+void
+FilsDiscHeader::FdCapability::SetMaxNss(uint8_t maxNss)
+{
+    NS_ABORT_MSG_IF(maxNss < 1, "NSS is equal to 0");
+    maxNss--;
+    // 4 is the maximum value for the Maximum Number of Spatial Streams subfield
+    m_maxNss = std::min<uint8_t>(maxNss, 4);
+}
+
+uint8_t
+FilsDiscHeader::FdCapability::GetMaxNss() const
+{
+    return m_maxNss + 1;
+}
+
+void
+FilsDiscHeader::FdCapability::SetStandard(WifiStandard standard)
+{
+    switch (standard)
+    {
+    case WIFI_STANDARD_80211b:
+        m_phyIdx = 0;
+        break;
+    case WIFI_STANDARD_80211a:
+    case WIFI_STANDARD_80211g:
+        m_phyIdx = 1;
+        break;
+    case WIFI_STANDARD_80211n:
+        m_phyIdx = 2;
+        break;
+    case WIFI_STANDARD_80211ac:
+        m_phyIdx = 3;
+        break;
+    case WIFI_STANDARD_80211ax:
+        m_phyIdx = 4;
+        break;
+    case WIFI_STANDARD_80211be:
+        m_phyIdx = 5;
+        break;
+    default:
+        NS_ABORT_MSG("Unsupported standard: " << standard);
+    }
+}
+
+WifiStandard
+FilsDiscHeader::FdCapability::GetStandard(WifiPhyBand band) const
+{
+    switch (m_phyIdx)
+    {
+    case 0:
+        return WIFI_STANDARD_80211b;
+    case 1:
+        NS_ABORT_MSG_IF(band != WIFI_PHY_BAND_2_4GHZ && band != WIFI_PHY_BAND_5GHZ,
+                        "Invalid PHY band (" << band << ") with PHY index of 1");
+        return band == WIFI_PHY_BAND_5GHZ ? WIFI_STANDARD_80211a : WIFI_STANDARD_80211g;
+    case 2:
+        return WIFI_STANDARD_80211n;
+    case 3:
+        return WIFI_STANDARD_80211ac;
+    case 4:
+        return WIFI_STANDARD_80211ax;
+    case 5:
+        return WIFI_STANDARD_80211be;
+    default:
+        NS_ABORT_MSG("Invalid PHY index: " << m_phyIdx);
+    }
+
+    return WIFI_STANDARD_UNSPECIFIED;
+}
+
 } // namespace ns3
